#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QGraphicsScene>
#include <QGraphicsRectItem>
#include <QGraphicsEllipseItem>

#if 0
class W
{
public:
    int w ;
    virtual void f () { }

    static int cnt;
    W () { cnt ++; }
};

int W::cnt = 0;

class A : virtual public W
{
public:
    int x;
    virtual void f () { x = 1; }
};

class B : virtual public W
{
public:
    int y;
    virtual void f () { y = 2; }
};

class C : public A, public B
{
public:
   int z;
   virtual void f () { z = 3; }
};

inline QString num (int n)
{
    return QString::number (n);
}

inline QString num (void * n)
{
    return num ((long) n);
}
#endif

class MyData
{
protected:
   QAbstractGraphicsShapeItem * shape;
public:
    MyData ( QAbstractGraphicsShapeItem * s) : shape (s) { }
    virtual void change () { shape->setOpacity (0.5);};

};

class MyRectangle : public QGraphicsRectItem, public MyData
{
public:
    MyRectangle () : MyData (this) { }
    // virtual void change () {  };

};

class MyEllipse : public QGraphicsEllipseItem, public MyData
{
public:
    MyEllipse () : MyData (this) { }
    // virtual void change () { setBrush(QColor ("greenyellow")); }
};


void MainWindow::on_actionTest_triggered()
{
   #if 0
    put ( "sizeof W = " + num (sizeof (W)) );
    put ( "sizeof A = " + num (sizeof (A)) );
    put ( "sizeof B = " + num (sizeof (B)) );
    put ( "sizeof C = " + num (sizeof (C)) );

    C * p = new C ();
    put ( "cnt = " + num (W::cnt) );
    put ( "addr C = " + num (p) );
    A * a = p;
    put ( "addr A = " + num (a) );
    B * b = p;
    put ( "addr B = " + num (b) );

    a->f();
    put ("x= " + num (p->x));
    #endif
}


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QGraphicsScene * scene = new QGraphicsScene ();
    ui->graphicsView->setScene (scene);
    scene->setSceneRect (0, 0, 1024, 800);

    QGraphicsRectItem * r = new MyRectangle;
    r->setRect (50, 50, 300, 200);
    r->setToolTip ("obdelnik");
    r->setPen (QColor ("blue"));
    r->setBrush (QColor ("yellow"));
    r->setFlag (QGraphicsItem::ItemIsMovable);
    r->setFlag (QGraphicsItem::ItemIsSelectable);
    scene->addItem (r);

    QGraphicsEllipseItem * e = new MyEllipse;
    e->setRect (400, 100, 300, 200);
    e->setToolTip ("elipsa");
    e->setPen (QColor ("red"));
    e->setBrush (QColor ("cornflowerblue"));
    e->setFlag (QGraphicsItem::ItemIsMovable);
    e->setFlag (QGraphicsItem::ItemIsSelectable);
    scene->addItem (e);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::put (QString s)
{
    ui->plainTextEdit->appendPlainText (s);
}

// #include <QAbstractGraphicsShapeItem>

void MainWindow::on_actionRun_triggered()
{
     QList<QGraphicsItem *> list = ui->graphicsView->scene()->selectedItems ();
     put ("list");
     foreach (QGraphicsItem * item, list)
     {
         put ("item " + item->toolTip() );
         MyData * p = dynamic_cast < MyData* > (item);
         if (p != NULL)
             p->change ();

         /*
         item->setOpacity (0.5);

         QAbstractGraphicsShapeItem * s =
                 dynamic_cast < QAbstractGraphicsShapeItem * > (item);
         if (s != NULL)
             s->setBrush(QColor ("greenyellow"));

         QGraphicsRectItem * r = dynamic_cast < QGraphicsRectItem * > (item);
         if (r != NULL)
             r->setRect (r->x(), r->y(),
                         r->rect().width()-10, r->rect().height()-10);
          */
     }
}

